#include <minigui.ch>

Function Main

        Load Window Main
        Main.Center
        Main.Activate

Return



Function BackupData()
    LOCAL cZipFile, cFolder, aDirectory := {}, aFiles := {}
    
    cFolder := alltrim(main.lblSourceFolder.value)
    
    cZipFile := alltrim(main.lblDestZipFile.value)
    
    if empty(cFolder)
    	msginfo("Please select source folder")
    	return nil
    endif
    
    if empty(cZipFile)
    	msginfo("Please specify zip file")
    	return nil
    endif
    
    
    aDirectory := directory(cFolder+"\*.dbf")
    
    if len(aDirectory) = 0
    	msginfo("No file to backup")
    	return nil
    endif
    
    aeval(aDirectory, {|x| aadd(aFiles, cFolder+"\"+x[1])})
    
    main.pbBackup.value := 0
    main.pbBackup.visible := .t.
		
    HB_ZipFile(cZipFile, aFiles, 8, {|cFile,nPos| main.pbBackup.value := nPos/len(aFiles)*100 }, .t.)
				
    main.pbBackup.value := 0
    main.pbBackup.visible := .f.
    
	return nil



Function RestoreData()
    LOCAL cZipFile, cFolder, aDirectory := {}, aFiles := {}

    cFolder := alltrim(main.lblDestFolder.value)

    cZipFile := alltrim(main.lblSourceZipFile.value)

    if empty(cFolder)
    	msginfo("Please select destination folder")
    	return nil
    endif
        
    if empty(cZipFile)
    	msginfo("Please select zip file")
    	return nil
    endif 
    
    aFiles := HB_GetFilesInZip(cZipFile)
    
    main.pbRestore.value := 0
    main.pbRestore.visible := .t.
    	
    HB_UnzipFile(cZipFile, {|cFile,nPos| main.pbRestore.value := nPos/len(aFiles)*100 },,, cFolder+"\", aFiles)

    main.pbRestore.value := 0
    main.pbRestore.visible := .f.
    
	return nil
	
	
	
	

#pragma BEGINDUMP

#include "windows.h"
#include "hbapi.h"

HB_FUNC( CSAVEFILE )
{
    OPENFILENAME ofn;

    char File[ MAX_PATH ] = "";
    char Filter[ MAX_PATH ] = "";

    if ( ISCHAR( 1 ) )
        lstrcpy( File, hb_parc( 1 ) );
    
    if ( ISCHAR( 2 ) )
       lstrcpy( Filter, hb_parc( 2 ) ) ;
    

    ofn.lStructSize       = 76;
    ofn.hwndOwner         = GetActiveWindow();
//    ofn.lpstrFilter       = "Excel(*.xls,*.csv)\0*.xls;*.csv\0All(*.*)\0*.*\0";
   ofn.lpstrFilter       = Filter;
    ofn.lpstrCustomFilter = 0;
    ofn.nFilterIndex      = 1;
    ofn.lpstrFile         = File;
    ofn.nMaxFile          = MAX_PATH;
    ofn.lpstrFileTitle    = 0;
    //ofn.lpstrInitialDir   = 0;
    ofn.lpstrTitle        = "Save As";
    ofn.Flags             = OFN_HIDEREADONLY | OFN_NOCHANGEDIR | OFN_SHAREAWARE |
OFN_NODEREFERENCELINKS | OFN_NOTESTFILECREATE | OFN_PATHMUSTEXIST |
OFN_OVERWRITEPROMPT ;
    ofn.lpstrDefExt       = 0;

    if ( GetSaveFileName( &ofn ) )
        hb_retclen( File, lstrlen( File ) );
    else
        hb_retc( "" );

}



HB_FUNC( COPENFILE )
{
    OPENFILENAME ofn;

    char File[ MAX_PATH ] = "";
    char Filter[ MAX_PATH ] = "";

    if ( ISCHAR( 1 ) )
        lstrcpy( File, hb_parc( 1 ) );
    
    if ( ISCHAR( 2 ) )
       lstrcpy( Filter, hb_parc( 2 ) ) ;
    

    ofn.lStructSize       = 76;
    ofn.hwndOwner         = GetActiveWindow();
//    ofn.lpstrFilter       = "Excel(*.xls,*.csv)\0*.xls;*.csv\0All(*.*)\0*.*\0";
   ofn.lpstrFilter       = Filter;
    ofn.lpstrCustomFilter = 0;
    ofn.nFilterIndex      = 1;
    ofn.lpstrFile         = File;
    ofn.nMaxFile          = MAX_PATH;
    ofn.lpstrFileTitle    = 0;
    //ofn.lpstrInitialDir   = 0;
    ofn.lpstrTitle        = "Open";
    ofn.Flags             = OFN_HIDEREADONLY | OFN_NOCHANGEDIR | OFN_SHAREAWARE |
OFN_NODEREFERENCELINKS | OFN_NOTESTFILECREATE | OFN_PATHMUSTEXIST |
OFN_OVERWRITEPROMPT ;
    ofn.lpstrDefExt       = 0;

    if ( GetOpenFileName( &ofn ) )
        hb_retclen( File, lstrlen( File ) );
    else
        hb_retc( "" );

}

#pragma ENDDUMP 